// DispStruct.h : Declaration of the CDispStruct

#ifndef __DISPSTRUCT_H_
#define __DISPSTRUCT_H_

#include "resource.h"       // main symbols

///////////////////////////////////////////////////////////
// CDispStruct
class ATL_NO_VTABLE CDispStruct : 
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CDispStruct, &CLSID_DispStruct>,
    public IDispatch
{
public:
    CDispStruct(): 
        m_pRecord(0), m_pOuterRecord(0), 
        m_dispidMin(0), m_dispidMax(0)
    {
    }

    ~CDispStruct();

DECLARE_REGISTRY_RESOURCEID(IDR_DISPSTRUCT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDispStruct)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY_IID(DIID_IDispStruct, IDispatch)
END_COM_MAP()

public:
    // IDispatch
    STDMETHOD(GetTypeInfoCount)(/* [out] */ UINT* pctinfo);
    
    STDMETHOD(GetTypeInfo)(
        /* [in] */ UINT iTInfo, 
        /* [in] */ LCID lcid,
        /* [out] */ ITypeInfo** ppTInfo);
    
    STDMETHOD(GetIDsOfNames)(
        /* [in] */ REFIID riid, 
        /* [size_is][in] */ LPOLESTR* rgszNames,
        /* [in] */ UINT cNames, 
        /* [in] */ LCID lcid, 
        /* [size_is][out] */ DISPID* rgDispId);
    
    STDMETHOD(Invoke)(
        /* [in] */ DISPID dispIdMember, 
        /* [in] */ REFIID riid,
        /* [in] */ LCID lcid, 
        /* [in] */ WORD wFlags, 
        /* [out][in] */ DISPPARAMS* pDispParams,
        /* [out] */ VARIANT* pVarResult, 
        /* [out] */ EXCEPINFO* pExcepInfo, 
        /* [out] */ UINT* puArgErr);

protected:
    // IDispStruct
    void CreateRecord(BSTR TypeLib, BSTR TypeName);
    VARIANT GetRecord();
    void SetRecord(const VARIANT& vaRecord);

    void PutField(BSTR bstrName, VARIANT& vaField);
    VARIANT GetField(DISPID dispIdMember, BSTR bstrName);

    void LinkToOuterRecord(CDispStruct* pOuterRecord, 
                 ITypeInfoPtr spTypeInfo, VARDESC* pvardesc);
    void DestroyRecord();
    void SetupAutomationStruct();
    void CleanNamesArray();

protected:
    static ITypeInfoPtr GetTypeInfo(LCID lcid);

protected:
    IRecordInfoPtr m_spRecordInfo;
    void* m_pRecord;
    CDispStruct* m_pOuterRecord;

    DISPID m_dispidMin;
    DISPID m_dispidMax;
    typedef std::vector<BSTR> NamesArray_t;
    NamesArray_t m_lstMemberNames;
};

#endif //__DISPSTRUCT_H_
