#ifndef __MESSAGEDIALOG_H_
#define __MESSAGEDIALOG_H_

#include "Resrc.h"       // main symbols
#include "Message.h"

class CMessageDialog
{
public:
    CMessageDialog(bool mode = false) 
        : mMessageText(NULL), mAddress(NULL) 
    {
        psThis = this;
        if(mode)
            ::DialogBox(_Module.GetModuleInstance(), 
                  MAKEINTRESOURCE(IDD_MESSAGEDIALOG),
                  ::GetActiveWindow(), CMessageDialog::DlgProc);
        else
            mhWnd = ::CreateDialog(_Module.GetModuleInstance(), 
                     MAKEINTRESOURCE(IDD_MESSAGEDIALOG), 
                     ::GetActiveWindow(), CMessageDialog::DlgProc);
    }

    virtual ~CMessageDialog() { Close(mhWnd); mhWnd = NULL; }

    static BOOL APIENTRY DlgProc(HWND hw, UINT message, 
                                 WPARAM wParam, LPARAM) 
    { 
        if(message == WM_INITDIALOG) return TRUE;      // set focus
        if(message == WM_COMMAND)
        {
            if(LOWORD(wParam) == IDOK)
                CMessageDialog::psThis->OnOK(hw);
            if(LOWORD(wParam) == IDCANCEL)
                CMessageDialog::psThis->OnCancel(hw);
        }
        return FALSE;
    } 

    void Show()
    {
        if(::IsWindow(mhWnd)) 
        {
            if(mMessageText) 
	        ::SetDlgItemText(mhWnd, IDC_EDIT1,  mMessageText);
            if(mAddress) 
                ::SetDlgItemText(mhWnd, IDC_EDIT2,  mAddress);
            ::ShowWindow(mhWnd, _Module.GetShowCmd()); 
        }
    }

    void Close(HWND hw)
    {
        if(::IsWindow(hw)) ::DestroyWindow(hw); 
    }

    void OnOK(HWND hw)
    {
        DWORD bufferSize = 1000;
        WCHAR buffer[1001];

        if(GetDlgItemText(hw, IDC_EDIT1, buffer, 1001))
        {
            if(mMessageText) ::CoTaskMemFree(mMessageText);
            mMessageText = (WCHAR*)::CoTaskMemAlloc(
                            sizeof(WCHAR) * (wcslen(buffer) + 1));
            wcscpy(mMessageText, buffer);
        }

        if(GetDlgItemText(hw, IDC_EDIT2, buffer, 1000))
        {
            if(mAddress) ::CoTaskMemFree(mAddress);
            mAddress = (WCHAR*)::CoTaskMemAlloc(
                        sizeof(WCHAR) * (wcslen(buffer) + 1));
            wcscpy(mAddress, buffer);
        }
        this->Close(hw);
              // Create a CSimpleMessage on the destination machine
        COSERVERINFO serverInfo = {0, mAddress, NULL, 0};
        IClassFactory* piFactory = NULL;
        ISimpleMessage* piMessage = NULL;

        MULTI_QI itfs[1]= { {&IID_ISimpleMessage, NULL, 0} };
        if(SUCCEEDED(CoCreateInstanceEx(CLSID_SimpleMessage, NULL,
                     CLSCTX_REMOTE_SERVER | CLSCTX_LOCAL_SERVER, 
                     &serverInfo, 1, itfs)))
        {
            if(::GetComputerName(buffer, &bufferSize))
            {                              // insert return address
                if(mAddress) ::CoTaskMemFree(mAddress);
                mAddress = (WCHAR*)::CoTaskMemAlloc(
                             sizeof(WCHAR) * (wcslen(buffer) + 1));
                wcscpy(mAddress, buffer);
            }
            piMessage = static_cast<ISimpleMessage*>(itfs[0].pItf);
            piMessage->ShowDialog(this);    // PASSING NON-COM PTR!
            piMessage->Release();
        }
        _Module.Unlock(); 
    }

    void OnCancel(HWND hw)
    {
        this->Close(hw); _Module.Unlock();
    }

    static HWND GetWindow() { if(!psThis) return 0;
                              return psThis->mhWnd; }
protected:
    WCHAR* mAddress;
    WCHAR* mMessageText;
private:
    HWND mhWnd;
    static CMessageDialog* psThis;
};
#endif //__MESSAGEDIALOG_H_
